# coding: utf-8

"""
    カラーミーショップ API

    # カラーミーショップ API  [カラーミーショップ](https://shop-pro.jp) APIでは、受注の検索や商品情報の更新を行うことができます。  ## 利用手順  はじめに、カラーミーデベロッパーアカウントを用意します。[デベロッパー登録ページ](https://api.shop-pro.jp/developers/sign_up)から登録してください。  次に、[登録ページ](https://api.shop-pro.jp/oauth/applications/new)からアプリケーション登録を行ってください。 スマートフォンのWebViewを利用する場合は、リダイレクトURLに`urn:ietf:wg:oauth:2.0:oob`を入力してください。  その後、カラーミーショップアカウントの認証ページを開きます。認証ページのURLは、`https://api.shop-pro.jp/oauth/authorize`に必要なパラメータをつけたものです。  |パラメータ名|値| |---|---| |`client_id`|アプリケーション詳細画面で確認できるクライアントID| |`response_type`|\"code\"という文字列| |`scope`| 別表参照| |`redirect_url`|アプリケーション登録時に入力したリダイレクトURL|  `scope`は、以下のうち、アプリケーションが利用したい機能をスペース区切りで指定してください。  |スコープ|機能| |---|---| |`read_products`|商品データの参照| |`write_products`|在庫データの更新| |`read_sales`|受注・顧客データの参照| |`write_sales`|受注データの更新|  以下のようなURLとなります。  ``` https://api.shop-pro.jp/oauth/authorize?client_id=CLIENT_ID&redirect_uri=REDIRECT_URL&response_type=code&scope=read_products%20write_products ```  初めてこのページを訪れる場合は、カラーミーショップアカウントのIDとパスワードの入力を求められます。 承認ボタンを押すと、このアプリケーションがショップのデータにアクセスすることが許可され、リダイレクトURLへリダイレクトされます。  承認された場合は、`code`というクエリパラメータに認可コードが付与されます。承認がキャンセルされた、またはエラーが起きた場合は、 `error`パラメータにエラーの内容を表す文字列が与えられます。  アプリケーション登録時のリダイレクトURLに`urn:ietf:wg:oauth:2.0:oob`を指定した場合は、以下のようなURLにリダイレクトされます。 末尾のパスが認可コードになっています。  ``` https://api.shop-pro.jp/oauth/authorize/AUTH_CODE ```  認可コードの有効期限は発行から10分間です。  最後に、認可コードとアクセストークンを交換します。以下のパラメータを付けて、`https://api.shop-pro.jp/oauth/token`へリクエストを送ります。  |パラメータ名|値| |---|---| |`client_id`|アプリケーション詳細画面に表示されているクライアントID| |`client_secret`|アプリケーション詳細画面に表示されているクライアントシークレット| |`code`|取得した認可コード| |`grant_type`|\"authorization_code\"という文字列| |`redirect_uri`|アプリケーション登録時に入力したリダイレクトURL|  ```console # curl での例  $ curl -X POST \\   -d'client_id=CLIENT_ID' \\   -d'client_secret=CLIENT_SECRET' \\   -d'code=CODE' \\   -d'grant_type=authorization_code'   \\   -d'redirect_uri=REDIRECT_URI'  \\   'https://api.shop-pro.jp/oauth/token' ```  リクエストが成功すると、以下のようなJSONが返ってきます。  ```json {   \"access_token\": \"d461ab8XXXXXXXXXXXXXXXXXXXXXXXXX\",   \"token_type\": \"bearer\",   \"scope\": \"read_products write_products\" } ```  アクセストークンに有効期限はありませんが、許可済みアプリケーション一覧画面から失効させることができます。なお、同じ認可コードをアクセストークンに交換できるのは1度だけです。  取得したアクセストークンは、Authorizationヘッダに入れて使用します。以下にショップ情報を取得する際の例を示します。  ```console # curlの例  $ curl -H 'Authorization: Bearer d461ab8XXXXXXXXXXXXXXXXXXXXXXXXX' https://api.shop-pro.jp/v1/shop.json ```  ## エラー  カラーミーショップAPI v1では  - エラーコード - エラーメッセージ - ステータスコード  の配列でエラーを表現します。以下に例を示します。  ```json {   \"errors\": [     {       \"code\": 404100,       \"message\": \"レコードが見つかりませんでした。\",       \"status\": 404     }   ] } ```   # noqa: E501

    OpenAPI spec version: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Product(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'str',
        'id': 'int',
        'name': 'str',
        'stocks': 'int',
        'stock_managed': 'bool',
        'few_num': 'int',
        'model_number': 'str',
        'category': 'object',
        'group_ids': 'list[int]',
        'display_state': 'str',
        'sales_price': 'int',
        'price': 'int',
        'members_price': 'int',
        'cost': 'int',
        'delivery_charge': 'int',
        'min_num': 'int',
        'max_num': 'int',
        'sale_start_date': 'int',
        'sale_end_date': 'int',
        'unit': 'str',
        'weight': 'int',
        'soldout_display': 'bool',
        'sort': 'int',
        'simple_expl': 'str',
        'expl': 'str',
        'mobile_expl': 'str',
        'smartphone_expl': 'str',
        'make_date': 'int',
        'update_date': 'int',
        'memo': 'str',
        'image_url': 'str',
        'mobile_image_url': 'str',
        'thumbnail_image_url': 'str',
        'images': 'list[object]',
        'options': 'list[ProductOption]',
        'variants': 'list[ProductVariant]',
        'pickups': 'list[object]'
    }

    attribute_map = {
        'account_id': 'account_id',
        'id': 'id',
        'name': 'name',
        'stocks': 'stocks',
        'stock_managed': 'stock_managed',
        'few_num': 'few_num',
        'model_number': 'model_number',
        'category': 'category',
        'group_ids': 'group_ids',
        'display_state': 'display_state',
        'sales_price': 'sales_price',
        'price': 'price',
        'members_price': 'members_price',
        'cost': 'cost',
        'delivery_charge': 'delivery_charge',
        'min_num': 'min_num',
        'max_num': 'max_num',
        'sale_start_date': 'sale_start_date',
        'sale_end_date': 'sale_end_date',
        'unit': 'unit',
        'weight': 'weight',
        'soldout_display': 'soldout_display',
        'sort': 'sort',
        'simple_expl': 'simple_expl',
        'expl': 'expl',
        'mobile_expl': 'mobile_expl',
        'smartphone_expl': 'smartphone_expl',
        'make_date': 'make_date',
        'update_date': 'update_date',
        'memo': 'memo',
        'image_url': 'image_url',
        'mobile_image_url': 'mobile_image_url',
        'thumbnail_image_url': 'thumbnail_image_url',
        'images': 'images',
        'options': 'options',
        'variants': 'variants',
        'pickups': 'pickups'
    }

    def __init__(self, account_id=None, id=None, name=None, stocks=None, stock_managed=None, few_num=None, model_number=None, category=None, group_ids=None, display_state=None, sales_price=None, price=None, members_price=None, cost=None, delivery_charge=None, min_num=None, max_num=None, sale_start_date=None, sale_end_date=None, unit=None, weight=None, soldout_display=None, sort=None, simple_expl=None, expl=None, mobile_expl=None, smartphone_expl=None, make_date=None, update_date=None, memo=None, image_url=None, mobile_image_url=None, thumbnail_image_url=None, images=None, options=None, variants=None, pickups=None):  # noqa: E501
        """Product - a model defined in OpenAPI"""  # noqa: E501

        self._account_id = None
        self._id = None
        self._name = None
        self._stocks = None
        self._stock_managed = None
        self._few_num = None
        self._model_number = None
        self._category = None
        self._group_ids = None
        self._display_state = None
        self._sales_price = None
        self._price = None
        self._members_price = None
        self._cost = None
        self._delivery_charge = None
        self._min_num = None
        self._max_num = None
        self._sale_start_date = None
        self._sale_end_date = None
        self._unit = None
        self._weight = None
        self._soldout_display = None
        self._sort = None
        self._simple_expl = None
        self._expl = None
        self._mobile_expl = None
        self._smartphone_expl = None
        self._make_date = None
        self._update_date = None
        self._memo = None
        self._image_url = None
        self._mobile_image_url = None
        self._thumbnail_image_url = None
        self._images = None
        self._options = None
        self._variants = None
        self._pickups = None
        self.discriminator = None

        if account_id is not None:
            self.account_id = account_id
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if stocks is not None:
            self.stocks = stocks
        if stock_managed is not None:
            self.stock_managed = stock_managed
        if few_num is not None:
            self.few_num = few_num
        if model_number is not None:
            self.model_number = model_number
        if category is not None:
            self.category = category
        if group_ids is not None:
            self.group_ids = group_ids
        if display_state is not None:
            self.display_state = display_state
        if sales_price is not None:
            self.sales_price = sales_price
        if price is not None:
            self.price = price
        if members_price is not None:
            self.members_price = members_price
        if cost is not None:
            self.cost = cost
        if delivery_charge is not None:
            self.delivery_charge = delivery_charge
        if min_num is not None:
            self.min_num = min_num
        if max_num is not None:
            self.max_num = max_num
        if sale_start_date is not None:
            self.sale_start_date = sale_start_date
        if sale_end_date is not None:
            self.sale_end_date = sale_end_date
        if unit is not None:
            self.unit = unit
        if weight is not None:
            self.weight = weight
        if soldout_display is not None:
            self.soldout_display = soldout_display
        if sort is not None:
            self.sort = sort
        if simple_expl is not None:
            self.simple_expl = simple_expl
        if expl is not None:
            self.expl = expl
        if mobile_expl is not None:
            self.mobile_expl = mobile_expl
        if smartphone_expl is not None:
            self.smartphone_expl = smartphone_expl
        if make_date is not None:
            self.make_date = make_date
        if update_date is not None:
            self.update_date = update_date
        if memo is not None:
            self.memo = memo
        if image_url is not None:
            self.image_url = image_url
        if mobile_image_url is not None:
            self.mobile_image_url = mobile_image_url
        if thumbnail_image_url is not None:
            self.thumbnail_image_url = thumbnail_image_url
        if images is not None:
            self.images = images
        if options is not None:
            self.options = options
        if variants is not None:
            self.variants = variants
        if pickups is not None:
            self.pickups = pickups

    @property
    def account_id(self):
        """Gets the account_id of this Product.  # noqa: E501

        ショップアカウントID  # noqa: E501

        :return: The account_id of this Product.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this Product.

        ショップアカウントID  # noqa: E501

        :param account_id: The account_id of this Product.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    @property
    def id(self):
        """Gets the id of this Product.  # noqa: E501

        商品ID  # noqa: E501

        :return: The id of this Product.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Product.

        商品ID  # noqa: E501

        :param id: The id of this Product.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this Product.  # noqa: E501

        商品名  # noqa: E501

        :return: The name of this Product.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Product.

        商品名  # noqa: E501

        :param name: The name of this Product.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def stocks(self):
        """Gets the stocks of this Product.  # noqa: E501

        在庫数  # noqa: E501

        :return: The stocks of this Product.  # noqa: E501
        :rtype: int
        """
        return self._stocks

    @stocks.setter
    def stocks(self, stocks):
        """Sets the stocks of this Product.

        在庫数  # noqa: E501

        :param stocks: The stocks of this Product.  # noqa: E501
        :type: int
        """

        self._stocks = stocks

    @property
    def stock_managed(self):
        """Gets the stock_managed of this Product.  # noqa: E501

        在庫管理するか否か  # noqa: E501

        :return: The stock_managed of this Product.  # noqa: E501
        :rtype: bool
        """
        return self._stock_managed

    @stock_managed.setter
    def stock_managed(self, stock_managed):
        """Sets the stock_managed of this Product.

        在庫管理するか否か  # noqa: E501

        :param stock_managed: The stock_managed of this Product.  # noqa: E501
        :type: bool
        """

        self._stock_managed = stock_managed

    @property
    def few_num(self):
        """Gets the few_num of this Product.  # noqa: E501

        残りわずかとなる在庫数  # noqa: E501

        :return: The few_num of this Product.  # noqa: E501
        :rtype: int
        """
        return self._few_num

    @few_num.setter
    def few_num(self, few_num):
        """Sets the few_num of this Product.

        残りわずかとなる在庫数  # noqa: E501

        :param few_num: The few_num of this Product.  # noqa: E501
        :type: int
        """

        self._few_num = few_num

    @property
    def model_number(self):
        """Gets the model_number of this Product.  # noqa: E501

        型番  # noqa: E501

        :return: The model_number of this Product.  # noqa: E501
        :rtype: str
        """
        return self._model_number

    @model_number.setter
    def model_number(self, model_number):
        """Sets the model_number of this Product.

        型番  # noqa: E501

        :param model_number: The model_number of this Product.  # noqa: E501
        :type: str
        """

        self._model_number = model_number

    @property
    def category(self):
        """Gets the category of this Product.  # noqa: E501


        :return: The category of this Product.  # noqa: E501
        :rtype: object
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this Product.


        :param category: The category of this Product.  # noqa: E501
        :type: object
        """

        self._category = category

    @property
    def group_ids(self):
        """Gets the group_ids of this Product.  # noqa: E501

        商品が属するグループのIDの配列  # noqa: E501

        :return: The group_ids of this Product.  # noqa: E501
        :rtype: list[int]
        """
        return self._group_ids

    @group_ids.setter
    def group_ids(self, group_ids):
        """Sets the group_ids of this Product.

        商品が属するグループのIDの配列  # noqa: E501

        :param group_ids: The group_ids of this Product.  # noqa: E501
        :type: list[int]
        """

        self._group_ids = group_ids

    @property
    def display_state(self):
        """Gets the display_state of this Product.  # noqa: E501

        掲載設定  # noqa: E501

        :return: The display_state of this Product.  # noqa: E501
        :rtype: str
        """
        return self._display_state

    @display_state.setter
    def display_state(self, display_state):
        """Sets the display_state of this Product.

        掲載設定  # noqa: E501

        :param display_state: The display_state of this Product.  # noqa: E501
        :type: str
        """
        allowed_values = ["showing", "hidden", "showing_for_members", "sale_for_members"]  # noqa: E501
        if display_state not in allowed_values:
            raise ValueError(
                "Invalid value for `display_state` ({0}), must be one of {1}"  # noqa: E501
                .format(display_state, allowed_values)
            )

        self._display_state = display_state

    @property
    def sales_price(self):
        """Gets the sales_price of this Product.  # noqa: E501

        販売価格  # noqa: E501

        :return: The sales_price of this Product.  # noqa: E501
        :rtype: int
        """
        return self._sales_price

    @sales_price.setter
    def sales_price(self, sales_price):
        """Sets the sales_price of this Product.

        販売価格  # noqa: E501

        :param sales_price: The sales_price of this Product.  # noqa: E501
        :type: int
        """

        self._sales_price = sales_price

    @property
    def price(self):
        """Gets the price of this Product.  # noqa: E501

        定価  # noqa: E501

        :return: The price of this Product.  # noqa: E501
        :rtype: int
        """
        return self._price

    @price.setter
    def price(self, price):
        """Sets the price of this Product.

        定価  # noqa: E501

        :param price: The price of this Product.  # noqa: E501
        :type: int
        """

        self._price = price

    @property
    def members_price(self):
        """Gets the members_price of this Product.  # noqa: E501

        会員価格  # noqa: E501

        :return: The members_price of this Product.  # noqa: E501
        :rtype: int
        """
        return self._members_price

    @members_price.setter
    def members_price(self, members_price):
        """Sets the members_price of this Product.

        会員価格  # noqa: E501

        :param members_price: The members_price of this Product.  # noqa: E501
        :type: int
        """

        self._members_price = members_price

    @property
    def cost(self):
        """Gets the cost of this Product.  # noqa: E501

        原価  # noqa: E501

        :return: The cost of this Product.  # noqa: E501
        :rtype: int
        """
        return self._cost

    @cost.setter
    def cost(self, cost):
        """Sets the cost of this Product.

        原価  # noqa: E501

        :param cost: The cost of this Product.  # noqa: E501
        :type: int
        """

        self._cost = cost

    @property
    def delivery_charge(self):
        """Gets the delivery_charge of this Product.  # noqa: E501

        個別送料  # noqa: E501

        :return: The delivery_charge of this Product.  # noqa: E501
        :rtype: int
        """
        return self._delivery_charge

    @delivery_charge.setter
    def delivery_charge(self, delivery_charge):
        """Sets the delivery_charge of this Product.

        個別送料  # noqa: E501

        :param delivery_charge: The delivery_charge of this Product.  # noqa: E501
        :type: int
        """

        self._delivery_charge = delivery_charge

    @property
    def min_num(self):
        """Gets the min_num of this Product.  # noqa: E501

        最小購入数量  # noqa: E501

        :return: The min_num of this Product.  # noqa: E501
        :rtype: int
        """
        return self._min_num

    @min_num.setter
    def min_num(self, min_num):
        """Sets the min_num of this Product.

        最小購入数量  # noqa: E501

        :param min_num: The min_num of this Product.  # noqa: E501
        :type: int
        """

        self._min_num = min_num

    @property
    def max_num(self):
        """Gets the max_num of this Product.  # noqa: E501

        最大購入数量  # noqa: E501

        :return: The max_num of this Product.  # noqa: E501
        :rtype: int
        """
        return self._max_num

    @max_num.setter
    def max_num(self, max_num):
        """Sets the max_num of this Product.

        最大購入数量  # noqa: E501

        :param max_num: The max_num of this Product.  # noqa: E501
        :type: int
        """

        self._max_num = max_num

    @property
    def sale_start_date(self):
        """Gets the sale_start_date of this Product.  # noqa: E501

        掲載開始時刻  # noqa: E501

        :return: The sale_start_date of this Product.  # noqa: E501
        :rtype: int
        """
        return self._sale_start_date

    @sale_start_date.setter
    def sale_start_date(self, sale_start_date):
        """Sets the sale_start_date of this Product.

        掲載開始時刻  # noqa: E501

        :param sale_start_date: The sale_start_date of this Product.  # noqa: E501
        :type: int
        """

        self._sale_start_date = sale_start_date

    @property
    def sale_end_date(self):
        """Gets the sale_end_date of this Product.  # noqa: E501

        掲載終了時刻  # noqa: E501

        :return: The sale_end_date of this Product.  # noqa: E501
        :rtype: int
        """
        return self._sale_end_date

    @sale_end_date.setter
    def sale_end_date(self, sale_end_date):
        """Sets the sale_end_date of this Product.

        掲載終了時刻  # noqa: E501

        :param sale_end_date: The sale_end_date of this Product.  # noqa: E501
        :type: int
        """

        self._sale_end_date = sale_end_date

    @property
    def unit(self):
        """Gets the unit of this Product.  # noqa: E501

        単位  # noqa: E501

        :return: The unit of this Product.  # noqa: E501
        :rtype: str
        """
        return self._unit

    @unit.setter
    def unit(self, unit):
        """Sets the unit of this Product.

        単位  # noqa: E501

        :param unit: The unit of this Product.  # noqa: E501
        :type: str
        """

        self._unit = unit

    @property
    def weight(self):
        """Gets the weight of this Product.  # noqa: E501

        重量(グラム単位)  # noqa: E501

        :return: The weight of this Product.  # noqa: E501
        :rtype: int
        """
        return self._weight

    @weight.setter
    def weight(self, weight):
        """Sets the weight of this Product.

        重量(グラム単位)  # noqa: E501

        :param weight: The weight of this Product.  # noqa: E501
        :type: int
        """

        self._weight = weight

    @property
    def soldout_display(self):
        """Gets the soldout_display of this Product.  # noqa: E501

        売り切れているときもショップに表示するか  # noqa: E501

        :return: The soldout_display of this Product.  # noqa: E501
        :rtype: bool
        """
        return self._soldout_display

    @soldout_display.setter
    def soldout_display(self, soldout_display):
        """Sets the soldout_display of this Product.

        売り切れているときもショップに表示するか  # noqa: E501

        :param soldout_display: The soldout_display of this Product.  # noqa: E501
        :type: bool
        """

        self._soldout_display = soldout_display

    @property
    def sort(self):
        """Gets the sort of this Product.  # noqa: E501

        表示順  # noqa: E501

        :return: The sort of this Product.  # noqa: E501
        :rtype: int
        """
        return self._sort

    @sort.setter
    def sort(self, sort):
        """Sets the sort of this Product.

        表示順  # noqa: E501

        :param sort: The sort of this Product.  # noqa: E501
        :type: int
        """

        self._sort = sort

    @property
    def simple_expl(self):
        """Gets the simple_expl of this Product.  # noqa: E501

        簡易説明  # noqa: E501

        :return: The simple_expl of this Product.  # noqa: E501
        :rtype: str
        """
        return self._simple_expl

    @simple_expl.setter
    def simple_expl(self, simple_expl):
        """Sets the simple_expl of this Product.

        簡易説明  # noqa: E501

        :param simple_expl: The simple_expl of this Product.  # noqa: E501
        :type: str
        """

        self._simple_expl = simple_expl

    @property
    def expl(self):
        """Gets the expl of this Product.  # noqa: E501

        商品説明  # noqa: E501

        :return: The expl of this Product.  # noqa: E501
        :rtype: str
        """
        return self._expl

    @expl.setter
    def expl(self, expl):
        """Sets the expl of this Product.

        商品説明  # noqa: E501

        :param expl: The expl of this Product.  # noqa: E501
        :type: str
        """

        self._expl = expl

    @property
    def mobile_expl(self):
        """Gets the mobile_expl of this Product.  # noqa: E501

        フィーチャーフォン向けショップの商品説明  # noqa: E501

        :return: The mobile_expl of this Product.  # noqa: E501
        :rtype: str
        """
        return self._mobile_expl

    @mobile_expl.setter
    def mobile_expl(self, mobile_expl):
        """Sets the mobile_expl of this Product.

        フィーチャーフォン向けショップの商品説明  # noqa: E501

        :param mobile_expl: The mobile_expl of this Product.  # noqa: E501
        :type: str
        """

        self._mobile_expl = mobile_expl

    @property
    def smartphone_expl(self):
        """Gets the smartphone_expl of this Product.  # noqa: E501

        スマホ向けショップの商品説明  # noqa: E501

        :return: The smartphone_expl of this Product.  # noqa: E501
        :rtype: str
        """
        return self._smartphone_expl

    @smartphone_expl.setter
    def smartphone_expl(self, smartphone_expl):
        """Sets the smartphone_expl of this Product.

        スマホ向けショップの商品説明  # noqa: E501

        :param smartphone_expl: The smartphone_expl of this Product.  # noqa: E501
        :type: str
        """

        self._smartphone_expl = smartphone_expl

    @property
    def make_date(self):
        """Gets the make_date of this Product.  # noqa: E501

        商品作成日時  # noqa: E501

        :return: The make_date of this Product.  # noqa: E501
        :rtype: int
        """
        return self._make_date

    @make_date.setter
    def make_date(self, make_date):
        """Sets the make_date of this Product.

        商品作成日時  # noqa: E501

        :param make_date: The make_date of this Product.  # noqa: E501
        :type: int
        """

        self._make_date = make_date

    @property
    def update_date(self):
        """Gets the update_date of this Product.  # noqa: E501

        商品更新日時  # noqa: E501

        :return: The update_date of this Product.  # noqa: E501
        :rtype: int
        """
        return self._update_date

    @update_date.setter
    def update_date(self, update_date):
        """Sets the update_date of this Product.

        商品更新日時  # noqa: E501

        :param update_date: The update_date of this Product.  # noqa: E501
        :type: int
        """

        self._update_date = update_date

    @property
    def memo(self):
        """Gets the memo of this Product.  # noqa: E501

        備考  # noqa: E501

        :return: The memo of this Product.  # noqa: E501
        :rtype: str
        """
        return self._memo

    @memo.setter
    def memo(self, memo):
        """Sets the memo of this Product.

        備考  # noqa: E501

        :param memo: The memo of this Product.  # noqa: E501
        :type: str
        """

        self._memo = memo

    @property
    def image_url(self):
        """Gets the image_url of this Product.  # noqa: E501

        メインの商品画像URL  # noqa: E501

        :return: The image_url of this Product.  # noqa: E501
        :rtype: str
        """
        return self._image_url

    @image_url.setter
    def image_url(self, image_url):
        """Sets the image_url of this Product.

        メインの商品画像URL  # noqa: E501

        :param image_url: The image_url of this Product.  # noqa: E501
        :type: str
        """

        self._image_url = image_url

    @property
    def mobile_image_url(self):
        """Gets the mobile_image_url of this Product.  # noqa: E501

        メインの商品画像のモバイル用URL  # noqa: E501

        :return: The mobile_image_url of this Product.  # noqa: E501
        :rtype: str
        """
        return self._mobile_image_url

    @mobile_image_url.setter
    def mobile_image_url(self, mobile_image_url):
        """Sets the mobile_image_url of this Product.

        メインの商品画像のモバイル用URL  # noqa: E501

        :param mobile_image_url: The mobile_image_url of this Product.  # noqa: E501
        :type: str
        """

        self._mobile_image_url = mobile_image_url

    @property
    def thumbnail_image_url(self):
        """Gets the thumbnail_image_url of this Product.  # noqa: E501

        メインの商品画像のサムネイルURL  # noqa: E501

        :return: The thumbnail_image_url of this Product.  # noqa: E501
        :rtype: str
        """
        return self._thumbnail_image_url

    @thumbnail_image_url.setter
    def thumbnail_image_url(self, thumbnail_image_url):
        """Sets the thumbnail_image_url of this Product.

        メインの商品画像のサムネイルURL  # noqa: E501

        :param thumbnail_image_url: The thumbnail_image_url of this Product.  # noqa: E501
        :type: str
        """

        self._thumbnail_image_url = thumbnail_image_url

    @property
    def images(self):
        """Gets the images of this Product.  # noqa: E501

        メインの商品画像以外の3つの画像に関する、PC用とモバイル用の画像URL  # noqa: E501

        :return: The images of this Product.  # noqa: E501
        :rtype: list[object]
        """
        return self._images

    @images.setter
    def images(self, images):
        """Sets the images of this Product.

        メインの商品画像以外の3つの画像に関する、PC用とモバイル用の画像URL  # noqa: E501

        :param images: The images of this Product.  # noqa: E501
        :type: list[object]
        """

        self._images = images

    @property
    def options(self):
        """Gets the options of this Product.  # noqa: E501

        選択できるオプションの一覧  # noqa: E501

        :return: The options of this Product.  # noqa: E501
        :rtype: list[ProductOption]
        """
        return self._options

    @options.setter
    def options(self, options):
        """Sets the options of this Product.

        選択できるオプションの一覧  # noqa: E501

        :param options: The options of this Product.  # noqa: E501
        :type: list[ProductOption]
        """

        self._options = options

    @property
    def variants(self):
        """Gets the variants of this Product.  # noqa: E501

        オプションのバリエーション一覧  # noqa: E501

        :return: The variants of this Product.  # noqa: E501
        :rtype: list[ProductVariant]
        """
        return self._variants

    @variants.setter
    def variants(self, variants):
        """Sets the variants of this Product.

        オプションのバリエーション一覧  # noqa: E501

        :param variants: The variants of this Product.  # noqa: E501
        :type: list[ProductVariant]
        """

        self._variants = variants

    @property
    def pickups(self):
        """Gets the pickups of this Product.  # noqa: E501

        おすすめ商品情報  # noqa: E501

        :return: The pickups of this Product.  # noqa: E501
        :rtype: list[object]
        """
        return self._pickups

    @pickups.setter
    def pickups(self, pickups):
        """Sets the pickups of this Product.

        おすすめ商品情報  # noqa: E501

        :param pickups: The pickups of this Product.  # noqa: E501
        :type: list[object]
        """

        self._pickups = pickups

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Product):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
