# coding: utf-8

"""
    カラーミーショップ API

    # カラーミーショップ API  [カラーミーショップ](https://shop-pro.jp) APIでは、受注の検索や商品情報の更新を行うことができます。  ## 利用手順  はじめに、カラーミーデベロッパーアカウントを用意します。[デベロッパー登録ページ](https://api.shop-pro.jp/developers/sign_up)から登録してください。  次に、[登録ページ](https://api.shop-pro.jp/oauth/applications/new)からアプリケーション登録を行ってください。 スマートフォンのWebViewを利用する場合は、リダイレクトURLに`urn:ietf:wg:oauth:2.0:oob`を入力してください。  その後、カラーミーショップアカウントの認証ページを開きます。認証ページのURLは、`https://api.shop-pro.jp/oauth/authorize`に必要なパラメータをつけたものです。  |パラメータ名|値| |---|---| |`client_id`|アプリケーション詳細画面で確認できるクライアントID| |`response_type`|\"code\"という文字列| |`scope`| 別表参照| |`redirect_url`|アプリケーション登録時に入力したリダイレクトURL|  `scope`は、以下のうち、アプリケーションが利用したい機能をスペース区切りで指定してください。  |スコープ|機能| |---|---| |`read_products`|商品データの参照| |`write_products`|在庫データの更新| |`read_sales`|受注・顧客データの参照| |`write_sales`|受注データの更新|  以下のようなURLとなります。  ``` https://api.shop-pro.jp/oauth/authorize?client_id=CLIENT_ID&redirect_uri=REDIRECT_URL&response_type=code&scope=read_products%20write_products ```  初めてこのページを訪れる場合は、カラーミーショップアカウントのIDとパスワードの入力を求められます。 承認ボタンを押すと、このアプリケーションがショップのデータにアクセスすることが許可され、リダイレクトURLへリダイレクトされます。  承認された場合は、`code`というクエリパラメータに認可コードが付与されます。承認がキャンセルされた、またはエラーが起きた場合は、 `error`パラメータにエラーの内容を表す文字列が与えられます。  アプリケーション登録時のリダイレクトURLに`urn:ietf:wg:oauth:2.0:oob`を指定した場合は、以下のようなURLにリダイレクトされます。 末尾のパスが認可コードになっています。  ``` https://api.shop-pro.jp/oauth/authorize/AUTH_CODE ```  認可コードの有効期限は発行から10分間です。  最後に、認可コードとアクセストークンを交換します。以下のパラメータを付けて、`https://api.shop-pro.jp/oauth/token`へリクエストを送ります。  |パラメータ名|値| |---|---| |`client_id`|アプリケーション詳細画面に表示されているクライアントID| |`client_secret`|アプリケーション詳細画面に表示されているクライアントシークレット| |`code`|取得した認可コード| |`grant_type`|\"authorization_code\"という文字列| |`redirect_uri`|アプリケーション登録時に入力したリダイレクトURL|  ```console # curl での例  $ curl -X POST \\   -d'client_id=CLIENT_ID' \\   -d'client_secret=CLIENT_SECRET' \\   -d'code=CODE' \\   -d'grant_type=authorization_code'   \\   -d'redirect_uri=REDIRECT_URI'  \\   'https://api.shop-pro.jp/oauth/token' ```  リクエストが成功すると、以下のようなJSONが返ってきます。  ```json {   \"access_token\": \"d461ab8XXXXXXXXXXXXXXXXXXXXXXXXX\",   \"token_type\": \"bearer\",   \"scope\": \"read_products write_products\" } ```  アクセストークンに有効期限はありませんが、許可済みアプリケーション一覧画面から失効させることができます。なお、同じ認可コードをアクセストークンに交換できるのは1度だけです。  取得したアクセストークンは、Authorizationヘッダに入れて使用します。以下にショップ情報を取得する際の例を示します。  ```console # curlの例  $ curl -H 'Authorization: Bearer d461ab8XXXXXXXXXXXXXXXXXXXXXXXXX' https://api.shop-pro.jp/v1/shop.json ```  ## エラー  カラーミーショップAPI v1では  - エラーコード - エラーメッセージ - ステータスコード  の配列でエラーを表現します。以下に例を示します。  ```json {   \"errors\": [     {       \"code\": 404100,       \"message\": \"レコードが見つかりませんでした。\",       \"status\": 404     }   ] } ```   # noqa: E501

    OpenAPI spec version: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from setuptools import setup, find_packages  # noqa: H301

NAME = "colormeshop"
VERSION = "1.0.0"
# To install the library, run the following
#
# python setup.py install
#
# prerequisite: setuptools
# http://pypi.python.org/pypi/setuptools

REQUIRES = ["urllib3 >= 1.15", "six >= 1.10", "certifi", "python-dateutil"]

setup(
    name=NAME,
    version=VERSION,
    description="カラーミーショップ API",
    author_email="",
    url="",
    keywords=["OpenAPI", "OpenAPI-Generator", "カラーミーショップ API"],
    install_requires=REQUIRES,
    packages=find_packages(),
    include_package_data=True,
    long_description="""\
    # カラーミーショップ API  [カラーミーショップ](https://shop-pro.jp) APIでは、受注の検索や商品情報の更新を行うことができます。  ## 利用手順  はじめに、カラーミーデベロッパーアカウントを用意します。[デベロッパー登録ページ](https://api.shop-pro.jp/developers/sign_up)から登録してください。  次に、[登録ページ](https://api.shop-pro.jp/oauth/applications/new)からアプリケーション登録を行ってください。 スマートフォンのWebViewを利用する場合は、リダイレクトURLに&#x60;urn:ietf:wg:oauth:2.0:oob&#x60;を入力してください。  その後、カラーミーショップアカウントの認証ページを開きます。認証ページのURLは、&#x60;https://api.shop-pro.jp/oauth/authorize&#x60;に必要なパラメータをつけたものです。  |パラメータ名|値| |---|---| |&#x60;client_id&#x60;|アプリケーション詳細画面で確認できるクライアントID| |&#x60;response_type&#x60;|\&quot;code\&quot;という文字列| |&#x60;scope&#x60;| 別表参照| |&#x60;redirect_url&#x60;|アプリケーション登録時に入力したリダイレクトURL|  &#x60;scope&#x60;は、以下のうち、アプリケーションが利用したい機能をスペース区切りで指定してください。  |スコープ|機能| |---|---| |&#x60;read_products&#x60;|商品データの参照| |&#x60;write_products&#x60;|在庫データの更新| |&#x60;read_sales&#x60;|受注・顧客データの参照| |&#x60;write_sales&#x60;|受注データの更新|  以下のようなURLとなります。  &#x60;&#x60;&#x60; https://api.shop-pro.jp/oauth/authorize?client_id&#x3D;CLIENT_ID&amp;redirect_uri&#x3D;REDIRECT_URL&amp;response_type&#x3D;code&amp;scope&#x3D;read_products%20write_products &#x60;&#x60;&#x60;  初めてこのページを訪れる場合は、カラーミーショップアカウントのIDとパスワードの入力を求められます。 承認ボタンを押すと、このアプリケーションがショップのデータにアクセスすることが許可され、リダイレクトURLへリダイレクトされます。  承認された場合は、&#x60;code&#x60;というクエリパラメータに認可コードが付与されます。承認がキャンセルされた、またはエラーが起きた場合は、 &#x60;error&#x60;パラメータにエラーの内容を表す文字列が与えられます。  アプリケーション登録時のリダイレクトURLに&#x60;urn:ietf:wg:oauth:2.0:oob&#x60;を指定した場合は、以下のようなURLにリダイレクトされます。 末尾のパスが認可コードになっています。  &#x60;&#x60;&#x60; https://api.shop-pro.jp/oauth/authorize/AUTH_CODE &#x60;&#x60;&#x60;  認可コードの有効期限は発行から10分間です。  最後に、認可コードとアクセストークンを交換します。以下のパラメータを付けて、&#x60;https://api.shop-pro.jp/oauth/token&#x60;へリクエストを送ります。  |パラメータ名|値| |---|---| |&#x60;client_id&#x60;|アプリケーション詳細画面に表示されているクライアントID| |&#x60;client_secret&#x60;|アプリケーション詳細画面に表示されているクライアントシークレット| |&#x60;code&#x60;|取得した認可コード| |&#x60;grant_type&#x60;|\&quot;authorization_code\&quot;という文字列| |&#x60;redirect_uri&#x60;|アプリケーション登録時に入力したリダイレクトURL|  &#x60;&#x60;&#x60;console # curl での例  $ curl -X POST \\   -d&#39;client_id&#x3D;CLIENT_ID&#39; \\   -d&#39;client_secret&#x3D;CLIENT_SECRET&#39; \\   -d&#39;code&#x3D;CODE&#39; \\   -d&#39;grant_type&#x3D;authorization_code&#39;   \\   -d&#39;redirect_uri&#x3D;REDIRECT_URI&#39;  \\   &#39;https://api.shop-pro.jp/oauth/token&#39; &#x60;&#x60;&#x60;  リクエストが成功すると、以下のようなJSONが返ってきます。  &#x60;&#x60;&#x60;json {   \&quot;access_token\&quot;: \&quot;d461ab8XXXXXXXXXXXXXXXXXXXXXXXXX\&quot;,   \&quot;token_type\&quot;: \&quot;bearer\&quot;,   \&quot;scope\&quot;: \&quot;read_products write_products\&quot; } &#x60;&#x60;&#x60;  アクセストークンに有効期限はありませんが、許可済みアプリケーション一覧画面から失効させることができます。なお、同じ認可コードをアクセストークンに交換できるのは1度だけです。  取得したアクセストークンは、Authorizationヘッダに入れて使用します。以下にショップ情報を取得する際の例を示します。  &#x60;&#x60;&#x60;console # curlの例  $ curl -H &#39;Authorization: Bearer d461ab8XXXXXXXXXXXXXXXXXXXXXXXXX&#39; https://api.shop-pro.jp/v1/shop.json &#x60;&#x60;&#x60;  ## エラー  カラーミーショップAPI v1では  - エラーコード - エラーメッセージ - ステータスコード  の配列でエラーを表現します。以下に例を示します。  &#x60;&#x60;&#x60;json {   \&quot;errors\&quot;: [     {       \&quot;code\&quot;: 404100,       \&quot;message\&quot;: \&quot;レコードが見つかりませんでした。\&quot;,       \&quot;status\&quot;: 404     }   ] } &#x60;&#x60;&#x60;   # noqa: E501
    """
)
